import * as SQLite from 'expo-sqlite';

function openDatabase() {
  if (Platform.OS === "web") {
    return {
      transaction: () => {
        return {
          executeSql: () => {},
        };
      },
    };
  }

  const db = SQLite.openDatabase("db.db");
  return db;
}

export const db = openDatabase();

export default function initDB() {
  return new Promise((resolve, reject) => {
    db.transaction((tx) => {
      tx.executeSql(
        'CREATE TABLE IF NOT EXISTS regions (id INTEGER PRIMARY KEY AUTOINCREMENT, region_id INTEGER, data TEXT);',
        [],
        resolve,
        (_, error) => reject(error),
      );
      tx.executeSql(
        'CREATE TABLE IF NOT EXISTS markers (id INTEGER PRIMARY KEY AUTOINCREMENT, a TEXT, d TEXT, g TEXT, i TEXT, marker_id INTEGER, l TEXT, m INTEGER, n TEXT, new INTEGER, s TEXT, sid INTEGER, v INTEGER);',
        [],
        resolve,
        (_, error) => reject(error),
      );
    });
  });
}
